#!/bin/sh
# Version: 0.1.0
# Author: Dimitrios Dimitrakos mail@dimitrios.de
# $Id$

. ~/.vdrconvert/vdrconvert.env

trap do_clean SIGINT SIGQUIT SIGTERM 


PIDFILE="$VCORUNDIR/`basename ${0}.pid`"
echo "$$" >> $PIDFILE

do_clean() {
	if [ -f $PIDFILE ]
	then
	    TEMPPID=$LTEMPDIR/`basename $PIDFILE`.$$
	    mv $PIDFILE $TEMPPID
	    status=$?
	    if [ $status -eq 0 ]
	    then
	        [ `cat $TEMPPID|wc -l` -gt 0 ] && cat $TEMPPID|grep -v $$ > $PIDFILE 
	    fi
	    [ -f $TEMPPID ] && rm $TEMPPID
	fi
	exit
}

Exit() {
	do_clean
}

[ "$DEBUG" = "yes" ] && set -x 

# Default werte setzen
# Verzeichnisse / Dateinamen
[ -z "$DIVX_DESTDIR" ] 	 && DIVX_DESTDIR=$DESTDIR/divx
[ -z "$DIVXTYPE" ] 	 && DIVXTYPE=lavc
[ -z "$DIVX_SUFFIX" ] 	 && DIVX_SUFFIX=avi
# Optionen
[ -z "$DIVXCCHOPT" ] 	 && DIVXCCHOPT="-cache 32768" 
[ -z "$DIVXENCOPT" ] 	 && DIVXENCOPT="" # Sonstige optionen
[ -z "$DIVXTCMODE" ] 	 && DIVXTCMODE=s
[ -z "$DIVXVLAVCCODEC" ] && DIVXVLAVCCODEC=mpeg4
[ -z "$DIVXQUALITY" ] 	 && DIVXQUALITY=5
[ -z "$DIVXMP3_OPTS" ] 	 && DIVXMP3_OPTS="-b 192 -h"
[ -z "$DIVXSWS" ] 	 && DIVXSWS=2
[ -z "$DIVXCDLEN" ] 	 && DIVXCDLEN=750
[ -z "$DIVXMAXBITR" ] 	 && DIVXMAXBITR=2480 
[ -z "$DIVXMINBITR" ] 	 && DIVXMINBITR=0
[ -z "$DIVX_MAXLEN" ]    && DIVX_MAXLEN=90
[ -z "$DIVX_MAXDIV" ]    && DIVX_MAXDIV=25
# Schalter
[ -z "$DIVXFAKTOR" ]	 && DIVXFAKTOR=2
[ -z "$DIVXAUTOCROP" ]	 && DIVXAUTOCROP=no
[ -z "$DIVX_SPLIT" ]	 && DIVX_SPLIT=no
[ -z "$DIVX_RESDIV" ]	 && DIVX_RESDIV=no
[ -z "$DIVX_USELAME" ]   && DIVX_USELAME=no
[ -z "$DIVX_ACODEC" ]    && DIVX_ACODEC=mp3lame

# Check ob alle Programme ausfhrbar sind
# TODO

NewJobs=$1
JOBFIL=$2
LOGFILE=$3
LTEMPDIR=${TEMPDIR}/${JOBFIL}

[ -d $DIVX_DESTDIR ] || mkdir -p $DIVX_DESTDIR
[ -d $LTEMPDIR ] || mkdir -p $LTEMPDIR
[ -z "$DIVX_TITLEDATE" ] && DIVX_TITLEDATE=$CONV_TITLEDATE

if [ -w ${LTEMPDIR} -a -w ${DIVX_DESTDIR} ]
then

  let NLLINES=`cat $VCOQUEUEDIR/${JOBFIL}|nl|wc -l|awk '{ print $1 }'`
  let ALINES=`cat $VCOQUEUEDIR/${JOBFIL}|wc -l|awk '{ print $1 }'`

  if [ $ALINES -ge 1 ]
  then
    TEMPJOBFILE=/$LTEMPDIR/${JOBFIL}.u.$$
    > $TEMPJOBFILE
    printf "%s\n" "`cat $VCOQUEUEDIR/${JOBFIL}|head -n 1`" > $NewJobs
    let LINE=2
    while [ $LINE -le $ALINES ]
    do
	printf "%s\n" "`cat $VCOQUEUEDIR/${JOBFIL}|head -n $LINE|tail -n 1`" >> $TEMPJOBFILE
	let LINE=LINE+1
    done
    [ $NLLINES -gt $ALINES ] && printf "%s" "`cat $VCOQUEUEDIR/${JOBFIL}|tail -n 1`" >> $TEMPJOBFILE
    cp $TEMPJOBFILE $VCOQUEUEDIR/${JOBFIL} && rm $TEMPJOBFILE

    while [ `cat $NewJobs|grep ^${VDRROOT}|wc -l` -gt 0 ]
    do
      USESTREAMS=$DIVXUSESTREAMS
      CMDLIN=`head -n 1 $NewJobs`   # Job auslesen
      let Number=1
      echo "`date` : Start conversion for $CMDLIN"
      for i in $CMDLIN
      do
	[ "$OSDMONITOR" = "yes" ] && $SVDRPSEND MESG "`echo $0|xargs basename` start for $i" >/dev/null 2>&1
	logger "$0 : start for $i"
	pxfiles=""
	[ "$DIVX_SPLIT" = "no" ] && p=${i}/ || p=`echo $i/[0-9][0-9[0-9]*.vdr`
	for j in $p
	do
          printf "\t`date` : Begin conversion %s\n" "$j"
	  UniqueDir[Number]=`mktemp -d ${LTEMPDIR}/VDRSYNC.XXXXXX`
	  status=$?
	  if [ $status -eq 0 ]
	  then
	      mkdir -p ${UniqueDir[Number]} 

	      r=`echo ${VDRROOT}|sed 's/\// /g'|wc -w`
	      spalten=`echo $i|sed 's/\// /g'|wc -w`
	      Record=`echo $i|sed 's/\%//g'|cut -f $spalten -d '/'`
	      [ $[$r+2] -lt $[$spalten-1] ] && SubTitel=`echo $i|sed 's/\%//g'|cut -f $[$r+2]-$[$spalten-1] -d '/'` || SubTitel=""
	      Datum=`basename $i|cut -f1 -d'.'`
	      if [ -z "$SubTitel" ]
	      then
		  [ "$DIVX_TITLEDATE" = "yes" ] && Titel=${Datum}_${Record} ||Titel=${Record}
	      else
		  [ "$DIVX_TITLEDATE" = "yes" ] && Titel=${SubTitel}/${Datum}_${Record} || Titel=${SubTitel}/${Record}
	      fi
	      [ ! -d ${UniqueDir[Number]}/${SubTitel} ] && mkdir -p ${UniqueDir[Number]}/${SubTitel}
	      [ ! -d ${DIVX_DESTDIR}/${SubTitel} ] && mkdir -p ${DIVX_DESTDIR}/${SubTitel}
	      cd ${UniqueDir[Number]} # Temporaere Dateien sollen hier erstellt werden
	      LOG[Number]=${UniqueDir[Number]}/sync.log

	      [ "$OSDMONITOR" = "yes" ] && $SVDRPSEND MESG "Try to demux with $DEMUXER" >/dev/null 2>&1
              printf "\t`date +"%T"`: Start demux with %s\n" ${DEMUXER}
              case `basename $DEMUXER` in
                vdrsync)
                  printf "`date +"%T"`\t: Start ${VDRSYNC}\n"
                  NEWSTREAMS[Number]=$USESTREAMS
                  nice -n $PRIO $VDRSYNC -o ${UniqueDir[Number]} $j > ${LOG[Number]} 2>&1
                  status=$?
                  [ "$DEBUG" = "yes" ] && cat ${LOG[Number]} >> $LOGFILE
                  if [ $status -ne 0 ]
                  then
                      echo "ERROR : $VDRSYNC  rc=$status"
                      # Cleaning
                      cd $VDRCONVERTDIR
                      rm -rf ${UniqueDir[Number]}
                      Exit 
                  fi
                  ;;
                vdrsync2)
                  printf "`date +"%T"`\t: Start ${VDRSYNC}\n"
                  NEWSTREAMS[Number]=$USESTREAMS
                  nice -n $PRIO $VDRSYNC -basename 001 -script-output $VDRSYNC_OPTS -o ${UniqueDir[Number]} $j > ${LOG[Number]} 2>&1
                  status=$?
                  [ "$DEBUG" = "yes" ] && cat ${LOG[Number]} >> $LOGFILE
                  if [ $status -ne 0 ]
                  then
                      echo "ERROR : $VDRSYNC  rc=$status"
                      # Cleaning
                      cd $VDRCONVERTDIR
                      rm -rf ${UniqueDir[Number]}
                      Exit 
                  fi
                  ;;
                px)
                  # Virtuellen X-Server starten
                  #$XVFB :1 >/dev/null 2>&1 &
                  export DISPLAY=:1.0
    
                  [ -d $j ] && vdrfiles=$j/[0-9][0-9][0-9].vdr || vdrfiles=$j
                  for l in $vdrfiles
                  do
                  let len=`$LS -Ls $l|awk '{print $1}'`
                  if [ $len -gt 1 ]
                  then
                          if [ -z "$pxfiles" -a "$l" != "001.vdr" ]
                          then
                                  pre=`echo $l|xargs basename|cut -f1 -d '.'`
                                  echo "s/001/$pre/g" > sedcmd
                                  NEWSTREAMS[Number]=`echo $USESTREAMS|sed -f sedcmd`
                                  rm sedcmd
                          fi
                          pxfiles="${pxfiles} ${l}"
                  fi
                  done
    
                  # Project X starten
                  nice -n $PRIO $JAVA -jar $PX -c $PXINI -o ${UniqueDir[Number]} $pxfiles > ${LOG[Number]} 2>&1
                  status=$?
                  [ "$DEBUG" = "yes" ] && cat ${LOG[Number]} >> $LOGFILE
    
                  # Virtuellen X-Server beenden
                  #$KILL -15 $XVFB >/dev/null
                  if [ $status -ne 0 ]
                  then
                      echo "ERROR : $PX  rc=$status"
                      # Cleaning
                      cd $VDRCONVERTDIR
                      rm -rf ${UniqueDir[Number]}
                      Exit 
                  fi
                  ;;
                pva)
                  # VDR Files zusammenfhren
                  [ -d $j ] && vdrfiles=$j/[0-9][0-9][0-9].vdr || vdrfiles=$j
                  cat $vdrfiles >> ${UniqueDir[Number]}/001.vdr
                  [ -f $i/marks.vdr ] && cp $i/marks.vdr ${UniqueDir[Number]}
                  [ -f $i/index.vdr ] && cp $i/index.vdr ${UniqueDir[Number]}
                  # Winpfad erstellen
              	  WINEPFAD=`echo ${UniqueDir[Number]}|sed 's/\//\\\/g'`
              	  WINEFILE="demux \"Z:${WINEPFAD}\\001.vdr\" \"Z:${WINEPFAD}\\001.mpv\" \"Z:${WINEPFAD}\\001.mpa\""
                  ## Jobfile anlegen
                  echo "offeryn pvas job v000001" > ${UniqueDir[Number]}/demux.ajb
                  echo "\$JOB" >> ${UniqueDir[Number]}/demux.ajb
                  echo "$WINEFILE" >> ${UniqueDir[Number]}/demux.ajb
                  cat $VDRCONVERTDIR/share/vdrconvert/pva/demux.template >> ${UniqueDir[Number]}/demux.ajb
    
                  #$XVFB :1 >/dev/null 2>&1 &
                  export DISPLAY=:1.0
    
                  nice -n $PRIO $WINE $VDRCONVERTDIR/share/vdrconvert/pva/cPVAS.exe ${UniqueDir[Number]}/demux.ajb > ${LOG[Number]} 2>&1
	          status=$?
                  [ "$DEBUG" = "yes" ] && cat ${LOG[Number]} >> $LOGFILE
                  [ -f "${UniqueDir[Number]}/001.mpv.ac3" ] && mv ${UniqueDir[Number]}/001.mpv.ac3 ${UniqueDir[Number]}/001.ac3
                  NEWSTREAMS[Number]=$USESTREAMS

                  #$KILL -15 $XVFB >/dev/null
                  ;;
                *)
                  echo "No support for Demuxer $DEMUXER"
                  logger "ERROR : $0 No support for Demuxer $DEMUXER"
	          [ "$OSDMONITOR" = "yes" ] && $SVDRPSEND MESG "`echo $0|xargs basename` No support for Demuxer $DEMUXER" >/dev/null 2>&1
                  ;;
              esac

	      AC3OPT=""
	      if [ $status -eq 0 ]
	      then
	        let ABITR=0
	        let field=0
	        if [ -z "$DIVXUSESTREAMS" ] 
	        then
		  [ "$DIVX_NOAC3" != "yes" -a -f ${UniqueDir[Number]}/*.ac3 ] && NEWSTREAMS[Number]=`echo ${UniqueDir[Number]}/*.ac3|xargs basename`
		  for ii in `$LS ${UniqueDir[Number]}/*.mpa ${UniqueDir[Number]}/*.mp2 2>/dev/null`
		  do
		         NEWSTREAMS[Number]="${NEWSTREAMS[Number]} `echo $ii|xargs basename`"
		  done
	        fi
	        for k in ${NEWSTREAMS[Number]}
	        do
		    if [ -f ${UniqueDir[Number]}/$k ]
		    then
		      id=`echo $k|cut -f1 -d '.'`
		      ids=`echo $k|cut -f2 -d '.'`
		      [ "$ids" = "mpa" -o "$ids" = "mp2" ] && ids=mp3
		      if [ $field -lt 2 ] 
		      then
		          MPLEXAUDIO=$MPLEXAUDIO`[ $field -eq 0 ] && echo "-p ${UniqueDir[Number]}/${id}.${ids} " || echo "-s ${UniqueDir[Number]}/${id}.${ids} "`
		      fi
		      if [ "${ids}" = "ac3" ] 
		      then
			AC3OPT="-aid 128 -oac copy" 
			let ABITR=ABITR+448
		      else
	                if [ "$DIVX_USELAME" != "no" ]
			then
	        	    [ "$OSDMONITOR" = "yes" ] && $SVDRPSEND MESG "`echo $0|xargs basename` start LAME" >/dev/null 2>&1
                	    printf "\t`date +"%T"`: Start LAME for %s.\n\t\t %s\n" "${Titel}" "$MPLEXAUDIO"
			    echo "--mp2input $DIVXMP3_OPTS ${UniqueDir[Number]}/$k ${UniqueDir[Number]}/${id}.${ids}"|xargs nice -n ${PRIO} $LAME > /dev/null 2>&1
	        	    AC3OPT="-oac copy"
			else
			    mv ${UniqueDir[Number]}/$k ${UniqueDir[Number]}/${id}.${ids}
	        	    [ -z "$AC3OPT" ] && AC3OPT="-oac $DIVX_ACODEC"
			fi
			let ABITR=ABITR+DIVXMP3R
		      fi
		      #break
		      let field=field+1
		    fi
		done

	        [ "$OSDMONITOR" = "yes" ] && $SVDRPSEND MESG "`echo $0|xargs basename` start TCMPLEX" >/dev/null 2>&1
                printf "\t`date +"%T"`: Start TCMPLEX for %s.\n\t\t %s\n" "${Titel}" "$MPLEXAUDIO"
	        nice -n ${PRIO} $TCMPLEX -i ${UniqueDir[Number]}/*.mpv $MPLEXAUDIO -m $DIVXTCMODE -o ${UniqueDir[Number]}/${Titel}.mpg >/dev/null 2>&1
		[ "$DEMUXER" = "pva" ] && rm ${UniqueDir[Number]}/001.vdr
	        rm -rf $VideoStream ${UniqueDir[Number]}/*.ac3 ${UniqueDir[Number]}/*.mpa ${UniqueDir[Number]}/*.mp2 $transfile.m2v 2>/dev/null
	        # Bitrate berechnen
	        # Erst Laenge in MB ( nur Info )
		case `basename $DEMUXER` in

		    vdrsync)
                  	let sec=`cat ${LOG[Number]}|grep "frames written for stream"|tail -n 1|cut -f2 -d '('|cut -f1 -d')'|awk '{print $1}'|cut -f1 -d'.'`
                  	let min=$((sec/60))
			;;
		    vdrsync2)
                  	let sec=`cat ${LOG[Number]}|grep "Total_time"|tail -n 1|cut -f2 -d '='|cut -f1 -d'.'`
                  	let min=$((sec/60))
			;;
	            px)
		  	let min=`strings ${LOG[Number]}|grep "Video:"|awk '{print $4}'|cut -f2 -d':'`
		  	let sec=$((min*60))
			;;
		    pva)
			let hours=`strings ${LOG[Number]}|grep "Video 1:"|cut -f2 -d ','|cut -f1 -d ':'|awk '{print $1}'|xargs expr 0 + `
			let min=`strings ${LOG[Number]}|grep "Video 1:"|cut -f2 -d ','|cut -f2 -d ':'|awk '{print $1}'|xargs expr 0 + `
			let fsec=`strings ${LOG[Number]}|grep "Video 1:"|cut -f2 -d ','|cut -f3 -d ':'|awk '{print $1}'|cut -f1 -d'.'|xargs expr 0 + `
			let sec=$(((hours*60)+(min*60)+fsec))
			;;
		    *)
			echo "ERROR : No support for Demuxer $DEMUXER"
			;;
		esac

		lmovie=`$LS -s --block-size=1024k ${UniqueDir[Number]}/${Titel}.mpg|awk '{print $1}'`
	        [ $min -eq 0 ] && let min=1
                [ "$DEBUG" = "yes" ] && echo "File ${Titel} hat eine Lnge von $min Minuten bei $lmovie MB"
	        if [ "$DIVX_USEFAKTOR" != "no" ]
	        then
	          # Bitrate kann berechnet werden
	          [ $DIVXCDLEN -gt $((lmovie/DIVXFAKTOR)) ] && LEN=$((lmovie/DIVXFAKTOR)) || LEN=$DIVXCDLEN
	          [ $LEN -le 0 ] && LEN=1
	          VBITRT=$(((((LEN*1024*8/1000)*1024)-(ABITR*min*60))/(min*60)))
	          [ $DIVXMINBITR -gt 0 -a $VBITRT -le $DIVXMINBITR ] && VBITRT=$DIVXMINBITR
	          [ "$DEBUG" = "yes" ] && echo "Berechnete Bitrate fr eine Lnge $LEN = $VBITRT"
	        else
		  # Bitrate ohne Faktor fr Brennen
		  if [ $((ABITR-1)) -gt 0 -a $DIVXMP3R -le $((ABITR-1)) ];then
		    [ "$DEBUG" = "yes" ] && echo "keine Audiobitrate, setze $DIVXMP3R kb/s"
		    ABITR=$DIVXMP3R
		  fi
		  
		  VBITRT=$((((DIVXCDLEN*1000)/sec)*8))
		  VBICD=$((((DIVXCDLEN*1000)/($DIVX_MAXLEN*60))*8))
		  DIVX_LMIN=$((DIVX_MAXLEN-DIVX_MAXDIV))
		  DIVX_LMAX=$((DIVX_MAXLEN+DIVX_MAXDIV))

		  if [ $((DIVX_LMIN-1)) -gt 0 -a $min -le $((DIVX_LMIN-1)) ];then
		    [ "$DEBUG" = "yes" ] && echo "Das Video($min min) ist kleiner als das CD-Minimum($DIVX_LMIN min)"
		    [ "$DEBUG" = "yes" ] && echo "berechne Bitrate fr $DIVX_MAXLEN min"
		    VBITRT=$(((VBITRT/DIVX_MAXLEN)*min))
		  else
		    if [ $min -gt 0 -a $((DIVX_LMAX+1)) -le $min ];then
		      [ "$DEBUG" = "yes" ] && echo "Das Video($min min) ist grer als das CD-Maximum($DIVX_LMAX min)"
		      [ "$DEBUG" = "yes" ] && echo "berechne Bitrate fr 2 CD's"
		      DIVXCDLEN=$(((DIVXCDLEN*2)-50))
		      DIVX_MAXLEN=$((DIVX_MAXLEN*2))
		      VBITRT=$((((DIVXCDLEN*1000)/sec)*8))
		      VBICD=$((((DIVXCDLEN*1000)/($DIVX_MAXLEN*60))*8))
		      DIVX_LMIN=$((DIVX_MAXLEN-DIVX_MAXDIV))
		      DIVX_LMAX=$((DIVX_MAXLEN+DIVX_MAXDIV))
		    else
		      [ "$DEBUG" = "yes" ] && echo "Das Video($min min) ist im Toleranzbereich von $DIVX_LMIN min bis $DIVX_LMAX min)"
		    fi
		  fi
		  FILELEN=$(((VBITRT*sec)/1000/8))
	          if [ $DIVXMINBITR -gt 0 -a $VBITRT -le $DIVXMINBITR ]
		  then
		    [ "$DEBUG" = "yes" ] && echo "ERROR : Berechnete bitrate kleiner als Minimal festgelegte $DIVXMINBITR im environment"
	  	    cd -
          	    rm -rf ${UniqueDir[Number]}
		    Exit
		  fi
		  VBITRT=$((VBITRT-ABITR))		
		
		  [ "$DEBUG" = "yes" ] && echo
		  [ "$DEBUG" = "yes" ] && echo "DIVXCDLEN   = $DIVXCDLEN MB"
		  [ "$DEBUG" = "yes" ] && echo "FILELEN     = $FILELEN MB"
		  [ "$DEBUG" = "yes" ] && echo
		  [ "$DEBUG" = "yes" ] && echo "VIDEO_LEN   = $min min"
		  [ "$DEBUG" = "yes" ] && echo "DIVX_MIN    = $DIVX_LMIN min"
		  [ "$DEBUG" = "yes" ] && echo "DIVX_LEN    = $DIVX_MAXLEN min"
		  [ "$DEBUG" = "yes" ] && echo "DIVX_MAX    = $DIVX_LMAX min"
		  [ "$DEBUG" = "yes" ] && echo "DIVX_MAXDIV = $DIVX_MAXDIV min"
		  [ "$DEBUG" = "yes" ] && echo "DIVXMINBITR = $DIVXMINBITR kb/s"
		  [ "$DEBUG" = "yes" ] && echo
		  [ "$DEBUG" = "yes" ] && echo "BitRate     = $((VBITRT+ABITR)) kb/s"
		  [ "$DEBUG" = "yes" ] && echo "BitRate AUD = $ABITR kb/s"
		  [ "$DEBUG" = "yes" ] && echo "BitRate VID = $VBITRT kb/s"
		  [ "$DEBUG" = "yes" ] && echo "BitRate CD  = $VBICD kb/s"
		  [ "$DEBUG" = "yes" ] && echo
	        fi


	        ASPECT=`$MENCODER -frames 0 ${UniqueDir[Number]}/${Titel}.mpg 2>/dev/null|grep aspect|cut -f1 -d ')'|awk '{print $5}'`
	        if [ "$ASPECT" = "3" ] 
	        then
    	          Y=`$MENCODER -frames 0 ${UniqueDir[Number]}/${Titel}.mpg 2>/dev/null|grep aspect|cut -f1 -d ')'|awk '{print $3}'|cut -f2 -d'x'`
    	          X=$((Y*16/9))
    	          ASPOPT="-vop scale=$X:$Y,lavcdeint -sws $DIVXSWS"
		  if [ "$DIVX_RESDIV" = "yes" ]
		  then
    	              XX=`$MENCODER -frames 0 ${UniqueDir[Number]}/${Titel}.mpg 2>/dev/null|grep aspect|cut -f1 -d ')'|awk '{print $3}'|cut -f1 -d'x'`
	              X=$((XX/2))
    	              Y=$(((X*9)/16))
    	              ASPOPT="-vop scale=$X:$Y,lavcdeint -sws $DIVXSWS"
		  fi
		  if [ "$DIVX_NORECALC" = "yes" ]
		  then
    	              X=`$MENCODER -frames 0 ${UniqueDir[Number]}/${Titel}.mpg 2>/dev/null|grep aspect|cut -f1 -d ')'|awk '{print $3}'|cut -f1 -d'x'`
    	              Y=$(((X*9)/16))
    	              ASPOPT="-vop scale=$X:$Y,lavcdeint -sws $DIVXSWS"
		  fi

	          DIVXCROP=""
		  let step=0
		  let crop_ok=0
                  if [ "$DIVXAUTOCROP" = "yes" ]
	          then
		      for k in 00:01:10 00:02:00 00:03:00 00:05:00 00:10:00 00:15:00 00:20:00 00:25:00 00:30:00 00:35:00 00:40:00 00:45:00 01:00:00 01:15:00 01:30:00
		      do
		        DIVXCROP[step]=""
                        nice -n ${PRIO} $MENCODER -ss $k -frames 100 $DIVXENCOPT $AC3OPT $DIVXCCHOPT $ASPOPT \
		          -vop cropdetect \
                          -mc 0 \
                          -vc mpeg12 \
                          -ovc lavc \
                          -lavcopts vcodec=$DIVXVLAVCCODEC:vhq:ildct:vqmin=2:vbitrate=$VBITRT \
                          -o /dev/null \
                          ${UniqueDir[Number]}/${Titel}.mpg > ${UniqueDir[Number]}/crop.log
			status=$?
			if [ $status -eq 0 ]
			then
		          DIVXCROP[step]=`cat ${UniqueDir[Number]}/crop.log|grep crop= |tail -n 1 | cut -f3 -d '('|sed 's/)//'|sed 's/-vop //'`
			  [ ! -z "${DIVXCROP[step]}" ] && let step=step+1
			fi
		      done
		      if [ $step -ge 2 ]
		      then
	                  until [ $step -eq 1 -o $crop_ok -eq 3 ] 
		          do
		      	      let crop_ok=0
		      	      let ustep=step
	                      until [ $ustep -eq 1 -o $crop_ok -eq 3 ] 
		              do
			  	if [ ! -z "${DIVXCROP[ustep]}" -a "${DIVXCROP[ustep]}" = "${DIVXCROP[ustep-1]}" ] 
				then
				   let crop_ok=crop_ok+1
				fi
				let ustep=ustep-1
		              done
			      let step=step-1
		          done
		      fi
		      if [ $crop_ok -eq 3 ]
		      then
		          CROPMIN=`echo ${DIVXCROP[step]}|cut -f 4 -d ':'`
			  echo "CROP : $crop_ok Treffer gefunden."
		          Y=$((Y-CROPMIN))
    	                  ASPOPT="-vop scale=$X:$Y,$DIVXCROP,lavcdeint -sws $DIVXSWS"
		      fi
	          fi
	        else
    	          Y=`$MENCODER -frames 0 ${UniqueDir[Number]}/${Titel}.mpg 2>/dev/null|grep aspect|cut -f1 -d ')'|awk '{print $3}'|cut -f2 -d'x'`
    	          X=$((Y*4/3))
    	          ASPOPT="-vop scale=$X:$Y,lavcdeint -sws $DIVXSWS"
		  if [ "$DIVX_RESDIV" = "yes" ] 
		  then
			YY=$((Y/2))
    	                X=$((YY*4/3))
			Y=$YY
    	                ASPOPT="-vop scale=$X:$Y,lavcdeint -sws $DIVXSWS"
		  fi
	        fi
   	 
	        [ "$OSDMONITOR" = "yes" ] && $SVDRPSEND MESG "start mencoder mode $DIVXTYPE for $i" >/dev/null 2>&1
	        [ "$OSDMONITOR" = "yes" ] && $SVDRPSEND MESG "ASPECT = ${ASPOPT}: ${X}:${Y} Bitr=${VBITRT}" >/dev/null 2>&1
	        for t in $DIVXTYPE
	        do
		  case $t in
		      lavc)
		          printf "\t`date +"%T"` Erstelle %s Format 2 Pass\n" "$t"
	                  for pass in 1 2 
	                  do
			    printf "\t`date +"%T"` : Start $MENCODER pass %d %s %s %s %s Videobitr. %s\n" $pass "$DIVXENCOPT" "$AC3OPT" "$DIVXCCHOPT" "$ASPOPT" "$VBITRT"
    	 	            nice -n ${PRIO} $MENCODER $DIVXENCOPT $AC3OPT $DIVXCCHOPT $ASPOPT \
		 	      -mc 0 \
		 	      -vc mpeg12 \
		 	      -passlogfile ${UniqueDir[Number]}/divx2pass.log \
		 	      -ovc lavc \
		 	      -lavcopts vcodec=$DIVXVLAVCCODEC:vhq:ildct:vpass=$pass:vqmin=2:vbitrate=$VBITRT \
		 	      -o ${UniqueDir[Number]}/output.avi \
		 	      ${UniqueDir[Number]}/${Titel}.mpg > ${LOG[Number]} 2>&1
	   		    status=$?
                            [ "$DEBUG" = "yes" ] && strings ${LOG[Number]} >> $LOGFILE
		          done
		          ;;
		      divx)
		          printf "\t`date +"%T"` Erstelle %s Format 2 Pass\n" "$t"
	                  for pass in 1 2 
	                  do
			    printf "\t`date +"%T"` : Start $MENCODER pass %d %s %s %s %s Videobitr. %s\n" $pass "$DIVXENCOPT" "$AC3OPT" "$DIVXCCHOPT" "$ASPOPT" "$VBITRT"
                            nice -n ${PRIO} $MENCODER $DIVXENCOPT $AC3OPT $DIVXCCHOPT $ASPOPT \
                              -mc 0 \
                              -vc mpeg12 \
                              -passlogfile ${UniqueDir[Number]}/divx2pass.log \
                              -ovc divx4 \
                              -divx4opts pass=$pass:q=$DIVXQUALITY:br=$VBITRT \
                              -o ${UniqueDir[Number]}/output.avi \
                              ${UniqueDir[Number]}/${Titel}.mpg > ${LOG[Number]} 2>&1
	   		    status=$?
                            [ "$DEBUG" = "yes" ] && strings ${LOG[Number]} >> $LOGFILE
		          done
                           ;;
		      xvid)
		          printf "\t`date +"%T"` Erstelle %s Format 2 Pass\n" "$t"
                          for pass in 1 2
                          do
			    printf "\t`date +"%T"` : Start $MENCODER pass %d %s %s %s %s Videobitr. %s\n" $pass "$DIVXENCOPT" "$AC3OPT" "$DIVXCCHOPT" "$ASPOPT" "$VBITRT"
                              nice -${PRIO} $MENCODER $DIVXENCOPT $AC3OPT $DIVXCCHOPT $ASPOPT \
                                  -mc 0 \
                                  -vc mpeg12 \
                                  -ovc xvid \
                                  -xvidencopts bitrate=$VBITRT:pass=$pass \
                                  -o ${UniqueDir[Number]}/output.avi \
                                  ${UniqueDir[Number]}/${Titel}.mpg > ${LOG[Number]} 2>&1
                              status=$?
                              [ "$DEBUG" = "yes" ] && strings ${LOG[Number]} >> $LOGFILE
                          done
                          ;;
		      divxlowq)
		          printf "\t`date +"%T"` Erstelle %s Format 1 Pass\n" "$t"
		          VBITRT=400
	                  X=$((X/2))
	                  Y=$((Y/2))
    	                  ASPOPT="-vop scale=$X:$Y,lavcdeint -sws $DIVXSWS"
                          printf "\t`date +"%T"` : Erstelle DivX LQ Format (q=1, bitr=400) sincle Pass\n"
	                  nice -n ${PRIO} $MENCODER $DIVXENCOPT $AC3OPT $DIVXCCHOPT $ASPOPT \
                              -mc 0 \
                              -vc mpeg12 \
                              -o ${UniqueDir[Number]}/output.avi \
                              -ovc divx4 \
                              -divx4opts q=1:br=400 \
                              ${UniqueDir[Number]}/${Titel}.mpg  > ${LOG[Number]} 2>&1
	                  status=$?
                          [ "$DEBUG" = "yes" ] && strings ${LOG[Number]} >> $LOGFILE
        	        ;;
    		      *)
        	           printf "`\tdate +"%T"` ERROR :Encodertype %s wird nicht untersttzt." "$t"
		           status=2001
        	        ;;
		  esac
	          if [ $status -ne 0 ]
	          then
	             [ "$OSDMONITOR" = "yes" ] && $SVDRPSEND MESG "`echo $0|xargs basename` for ${Titel} fail" >/dev/null 2>&1
	             echo "Bei der Konvertierung von ${Titel} ist es zu Fehlern gekommen.status=<${status}>"
	             logger "Bei der Konvertierung von ${Titel} ist es zu Fehlern gekommen.status=<${status}>"
	          else
		     if [ "$DIVX_EXPANDFILENAME" = "yes" ]
		     then
		         if [ ! -f ${DIVX_DESTDIR}/${Titel}_${t}_${VBITRT}.${DIVX_SUFFIX} ]
		         then
			     mkdir -p ${DIVX_DESTDIR}
		             mv ${UniqueDir[Number]}/output.avi ${DIVX_DESTDIR}/${Titel}_${t}_${VBITRT}.${DIVX_SUFFIX}
		             status=$?
			     File=${DIVX_DESTDIR}/${Titel}_${t}_${VBITRT}.${DIVX_SUFFIX}
		         else
		             let index=1
		             until [ ! -f ${DIVX_DESTDIR}/${Titel}_${t}_${VBITRT}_-$index.${DIVX_SUFFIX} ]
		             do
			         let index=index+1
		             done
			     mkdir -p ${DIVX_DESTDIR}
		             mv ${UniqueDir[Number]}/output.avi ${DIVX_DESTDIR}/${Titel}_${t}_${VBITRT}_-$index.${DIVX_SUFFIX}
		             status=$?
			     File=${DIVX_DESTDIR}/${Titel}_${t}_${VBITRT}_-$index.${DIVX_SUFFIX}
		         fi
		     else
		         if [ ! -f ${DIVX_DESTDIR}/${Titel}.${DIVX_SUFFIX} ]
		         then
			     mkdir -p ${DIVX_DESTDIR}
		             mv ${UniqueDir[Number]}/output.avi ${DIVX_DESTDIR}/${Titel}.${DIVX_SUFFIX}
		             status=$?
			     File=${DIVX_DESTDIR}/${Titel}.${DIVX_SUFFIX}
		         else
		             let index=1
		             until [ ! -f ${DIVX_DESTDIR}/${Titel}-$index.${DIVX_SUFFIX} ]
		             do
			         let index=index+1
		             done
			     mkdir -p ${DIVX_DESTDIR}
		             mv ${UniqueDir[Number]}/output.avi ${DIVX_DESTDIR}/${Titel}-$index.${DIVX_SUFFIX}
		             status=$?
			     File=${DIVX_DESTDIR}/${Titel}-$index.${DIVX_SUFFIX}
		         fi
		     fi
		     [ "$DIVX_PREVENT_TIME" != "no" ] && touch -r $j $File
	             [ "$OSDMONITOR" = "yes" ] && $SVDRPSEND MESG "`echo $0|xargs basename` : $File ready." >/dev/null 2>&1
		     if [ "$DIVX_AUTOWRITE" = "yes" ]
		     then
			cd -
			echo "$File:CD:DEL" >> $VCOQUEUEDIR/burn
			cd -
		     fi
	          fi
	        done
    	    fi
    	  fi
	  # Temp Files lschen
	  cd -
          rm -rf ${UniqueDir[Number]}
	  let Number=Number+1
          printf "\t`date` : Finish %s\n" "$i"
	done
      done
      echo "`date` : Parts from $CMDLIN completed"
      cp $NewJobs $NewJobs.$$
      grep -x -v "$CMDLIN" $NewJobs.$$ > $NewJobs 
      rm $NewJobs.$$
    done
    rm $NewJobs
  fi
else
    echo "Bitte die Schreibrechte fr ${LTEMPDIR} und ${DIVX_DESTDIR} berprfen. Keine verarbeitung mglich"
fi

printf "`date +"%d-%m-%2Y %T"` : Session %s end\n" "$0"
Exit
