#!/bin/sh
# Version: 0.1.0 
# Author: Dimitrios Dimitrakos mail@dimitrios.de
# $Id$

. ~/.vdrconvert/vdrconvert.env

PIDFILE="$VCORUNDIR/`basename ${0}.pid`"
echo "$$" >> $PIDFILE

trap do_clean SIGINT SIGQUIT SIGTERM 
do_clean() {
	if [ -f $PIDFILE ]
	then
	    TEMPPID=$LTEMPDIR/`basename $PIDFILE`.$$
	    mv $PIDFILE $TEMPPID
	    status=$?
	    if [ $status -eq 0 ]
	    then
	        [ `cat $TEMPPID|wc -l` -gt 0 ] && cat $TEMPPID|grep -v $$ > $PIDFILE 
	    fi
	    [ -f $TEMPPID ] && rm $TEMPPID
	fi
	exit
}

Exit() {
	do_clean
}

NewJobs=$1
JOBFIL=$2
LOGFILE=$3



[ "$DEBUG" = "yes" ] && set -x 

printf "`date +"%d-%m-%2Y %T"` : Session %s begin\n" "$0"

LTEMPDIR=${TEMPDIR}/${JOBFIL}

[ "$DEBUG" = "yes" ] && set -x || LOGFILE=/dev/null

# Default Options
[ -z "$MP3_DESTDIR" ]  && MP3_DESTDIR=$DESTDIR/mp3 
[ -z "$MP3_OPTS" ]     && MP3_OPTS="-b 192 -h --resample 44100"
[ -z "$MP3_SPLIT" ]    && MP3_SPLIT="no"
[ -z "$MPLAYERMP3SOURCE" ]    && MPLAYERMP3SOURCE=""
[ -z "$MP3_TITLEDATE" ] && MP3_TITLEDATE=$CONV_TITLEDATE
[ -z "$MP3_USE_MPG123" ] && MP3_USE_MPG123=no
#[ -z "$MP3USESTREAMS" -a "`basename $DEMUXER`" = "vdrsync" ]  && MP3USESTREAMS="c0.mpa c1.mpa"
#[ -z "$MP3USESTREAMS" -a "$`basename DEMUXER`" = "vdrsync2" ] && MP3USESTREAMS="0010.mpa 0011.mpa"
#[ -z "$MP3USESTREAMS" -a "$`basename DEMUXER`" = "px" ]       && MP3USESTREAMS="001_1.mp2 001.mp2"
#[ -z "$MP3USESTREAMS" -a "$`basename DEMUXER`" = "pva" ]      && MP3USESTREAMS="001-01.mpa 001.mpa"



[ -d $MP3_DESTDIR ] || mkdir -p $MP3_DESTDIR 
[ -d $LTEMPDIR ] || mkdir -p $LTEMPDIR

if [ -w ${LTEMPDIR} -a -w ${MP3_DESTDIR} ]
then
  let NLLINES=`cat $VCOQUEUEDIR/${JOBFIL}|nl|wc -l|awk '{ print $1 }'`
  let ALINES=`cat $VCOQUEUEDIR/${JOBFIL}|wc -l|awk '{ print $1 }'`

  if [ $ALINES -ge 1 ]
  then
	TEMPJOBFILE=/$LTEMPDIR/${JOBFIL}.u.$$
	> $TEMPJOBFILE
	printf "%s\n" "`cat $VCOQUEUEDIR/${JOBFIL}|head -n 1`" > $NewJobs
	let LINE=2
	while [ $LINE -le $ALINES ]
	do
		printf "%s\n" "`cat $VCOQUEUEDIR/${JOBFIL}|head -n $LINE|tail -n 1`" >> $TEMPJOBFILE
		let LINE=LINE+1
	done
	[ $NLLINES -gt $ALINES ] && printf "%s" "`cat $VCOQUEUEDIR/${JOBFIL}|tail -n 1`" >> $TEMPJOBFILE
	cp $TEMPJOBFILE $VCOQUEUEDIR/${JOBFIL} && rm $TEMPJOBFILE


    while [ `cat $NewJobs|grep ^${VDRROOT}|wc -l` -gt 0 ]
    do
      CMDLIN=`head -n 1 $NewJobs`   # Job auslesen
      let Number=1
      printf "\t`date +"%T"` Start conversion for List : \n"
      let part=0
      for i in $CMDLIN
      do
      	      let part=part+1
	      printf "\t\t %5d) %s\n" $part "$i"
      done
      for i in $CMDLIN
      do
	  [ "$OSDMONITOR" = "yes" ] && $SVDRPSEND MESG "`echo $0|xargs basename` start for $i" > /dev/null 2>&1
	  logger "`echo $0|xargs basename` start for $i"
	  pxfiles=""
	  USESTREAMS=""
          printf "\n\t`date` : Begin conversion %s\n" "$i"
	  r=`echo $VDRROOT|sed 's/\// /g'|wc -w`
	  spalten=`echo $i|sed 's/\// /g'|wc -w`
	  Record=`echo $i|sed 's/\%//g'|cut -f $spalten -d '/'`
	  [ $[$r+2] -lt $[$spalten-1] ] && SubTitel=`echo $i|sed 's/\%//g'|cut -f $[$r+2]-$[$spalten-1] -d '/'` || SubTitel=""
	  Datum=`basename $i|cut -f1 -d'.'`
	  if [ -z "$SubTitel" ]
	  then
		[ "$MP3_TITLEDATE" = "yes" ] && Titel=${Datum}_${Record} ||Titel=${Record}
	  else
		[ "$MP3_TITLEDATE" = "yes" ] && Titel=${SubTitel}/${Datum}_${Record} || Titel=${SubTitel}/${Record}
	  fi
	  [ ! -d ${MP3_DESTDIR}/`dirname ${Titel}` ] && mkdir -p ${MP3_DESTDIR}/`dirname ${Titel}`
	  if [ "$MP3_SPLIT" = "no" ]
	  then
	      UniqueDir[Number]=`mktemp -d ${LTEMPDIR}/VDRSYNC.XXXXXX`
	      mkdir -p ${UniqueDir[Number]}/${Titel}
	      cd ${UniqueDir[Number]}
	      LOG[Number]=${UniqueDir[Number]}/sync.log
	      [ "$OSDMONITOR" = "yes" ] && $SVDRPSEND MESG "Try demux with $DEMUXER" > /dev/null 2>&1
              printf "\t`date +"%T"`: Start demux with %s\n" ${DEMUXER}
              case `basename $DEMUXER` in
              vdrsync)
                nice -n $PRIO $VDRSYNC -audio-only -o ${UniqueDir[Number]} $i/ > ${LOG[Number]} 2>&1
                status=$?
                if [ $status -ne 0 ]
                then
                  echo "ERROR : $VDRSYNC  rc=$status"
	          [ "$OSDMONITOR" = "yes" ] && $SVDRPSEND MESG "ERROR : $VDRSYNC  rc=$status" > /dev/null 2>&1
		  logger "ERROR : $VDRSYNC  rc=$status"
                  # Cleaning
                  cd $VDRCONVERTDIR
                  rm -rf ${UniqueDir[Number]}
                  Exit
                fi
                ;;
              vdrsync2)
                nice -n $PRIO $VDRSYNC -audio-only -basename 001 -script-output $VDRSYNC_OPTS -o ${UniqueDir[Number]} $i/ > ${LOG[Number]} 2>&1
                status=$?
                if [ $status -ne 0 ]
                then
                  echo "ERROR : $VDRSYNC  rc=$status"
	          [ "$OSDMONITOR" = "yes" ] && $SVDRPSEND MESG "ERROR : $VDRSYNC  rc=$status" > /dev/null 2>&1
		  logger "ERROR : $VDRSYNC  rc=$status"
                  # Cleaning
                  cd $VDRCONVERTDIR
                  rm -rf ${UniqueDir[Number]}
                  Exit
                fi
                ;;
              px)
                # Virtuellen X-Server starten
                #$XVFB :1 >/dev/null 2>&1 &
                #export DISPLAY=:1.0

                vdrfiles=`$LS $i/[0-9][0-9][0-9].vdr`

                for l in $vdrfiles
                do
                  let len=`$LS -Ls $l|awk '{print $1}'`
                  [ $len -gt 1 ] && pxfiles="${pxfiles} ${l}"
                done

                # Project X starten
                nice -n $PRIO $JAVA -jar $PX -c $PXINI -o ${UniqueDir[Number]} $pxfiles > ${LOG[Number]} 2>&1
                status=$?

                # Virtuellen X-Server beenden
                #$KILL -15 $XVFB >/dev/null
                if [ $status -ne 0 ]
                then
                  echo "ERROR : $PX  rc=$status"
	          [ "$OSDMONITOR" = "yes" ] && $SVDRPSEND MESG "ERROR : $PX  rc=$status" > /dev/null 2>&1
		  logger "ERROR : $PX  rc=$status"
                  # Cleaning
                  cd $VDRCONVERTDIR
                  rm -rf ${UniqueDir[Number]}
                  Exit
                fi
                ;;
              pva)
                # VDR Files zusammenfuehren
                cat $i/[0-9][0-9][0-9].vdr >> ${UniqueDir[Number]}/001.vdr
	        [ -f $i/marks.vdr ] && cp $i/marks.vdr ${UniqueDir[Number]}
	        [ -f $i/index.vdr ] && cp $i/index.vdr ${UniqueDir[Number]}
                # Winpfad erstellen
              	WINEPFAD=`echo ${UniqueDir[Number]}|sed 's/\//\\\/g'`
              	WINEFILE="demux \"Z:${WINEPFAD}\\001.vdr\" \"Z:${WINEPFAD}\\001.mpv\" \"Z:${WINEPFAD}\\001.mpa\""
                ## Jobfile anlegen
                echo "offeryn pvas job v000001" > ${UniqueDir[Number]}/demux.ajb
                echo "\$JOB" >> ${UniqueDir[Number]}/demux.ajb
                echo "$WINEFILE" >> ${UniqueDir[Number]}/demux.ajb
                cat $VDRCONVERTDIR/share/vdrconvert/pva/demux.template >> ${UniqueDir[Number]}/demux.ajb

                #$XVFB :1 >/dev/null 2>&1 &
                #export DISPLAY=:1.0

                nice -n $PRIO $WINE $VDRCONVERTDIR/share/vdrconvert/pva/cPVAS.exe ${UniqueDir[Number]}/demux.ajb > ${LOG[Number]} 2>&1
                #[ -f "${UniqueDir[Number]}/001.mpv.ac3" ] && mv ${UniqueDir[Number]}/001.mpv.ac3 ${UniqueDir[Number]}/001.ac3

                #$KILL -15 $XVFB >/dev/null
                ;;
              *)
                printf "\t\tNo support for Demuxer %s\n" $DEMUXER
                logger "No support for Demuxer $DEMUXER"
              ;;
              esac

	      if [ -z "$MP3USESTREAMS" ] 
	      then
		 for ii in `$LS ${UniqueDir[Number]}/*.mpa ${UniqueDir[Number]}/*.mp2 2>/dev/null`
		 do
		     USESTREAMS="$USESTREAMS `echo $ii|xargs basename`"
		 done
	      else
		USESTREAMS=$MP3USESTREAMS
	      fi

	      for AUDIO in $USESTREAMS
	      do
	       if [ -f ${UniqueDir[Number]}/$AUDIO ]
	       then
	        # Mit Lame zu mp3
	        if [ "$MP3_USE_MPG123" != "yes" ]
	        then
	          [ "$OSDMONITOR" = "yes" ] && $SVDRPSEND MESG "start LAME for ${Titel}.mp3" > /dev/null 2>&1
                  printf "\t`date +"%T"`: Start LAME for %s in %s with $MP3_OPTS\n" "${AUDIO}" "${Titel}"
	          nice -n ${PRIO} $LAME --mp2input $MP3_OPTS ${UniqueDir[Number]}/$AUDIO ${UniqueDir[Number]}/${Titel}.mp3 > /dev/null 2>&1
	        else
	          [ "$OSDMONITOR" = "yes" ] && $SVDRPSEND MESG "start mpg123|lame for ${Titel}.mp3" > /dev/null 2>&1
                  printf "\t`date +"%T"`: Start impg123 | LAME for %s in %s with $MP3_OPTS\n" "${AUDIO}" "${Titel}"
	          nice -n $PRIO mpg123 -s -w - ${UniqueDir[Number]}/$AUDIO | $LAME $MP3_OPTS - ${UniqueDir[Number]}/${Titel}.mp3 > /dev/null 2>&1
	          rm -f out.$$.wav
	        fi
	        if [ -f ${UniqueDir[Number]}/${Titel}.mp3 ]
	        then
	            if [ ! -f ${MP3_DESTDIR}/${Titel}.mp3 ]
		    then
		             cp ${UniqueDir[Number]}/${Titel}.mp3 ${MP3_DESTDIR}/${Titel}.mp3
			     File=${MP3_DESTDIR}/${Titel}.mp3
	            else
		            let index=1
		            until [ ! -f ${MP3_DESTDIR}/${Titel}-$index.mp3 ]
		            do
			        let index=index+1
		            done
		            cp ${UniqueDir[Number]}/${Titel}.mp3 ${MP3_DESTDIR}/${Titel}-$index.mp3
			    File=${MP3_DESTDIR}/${Titel}-$index.mp3
	            fi
		    [ "$OSDMONITOR" = "yes" ] && $SVDRPSEND MESG "MP3 for $File success" > /dev/null 2>&1
                    printf "\t`date +"%T"`: MP3 for %s success\n" "$File"
		    logger "$0 : MP3 for $File success"
	        else
		    [ "$OSDMONITOR" = "yes" ] && $SVDRPSEND MESG "MP3 for $File fail" > /dev/null 2>&1
                    printf "\t`date +"%T"`: MP3 for %s fail\n" "$File"
		    logger "$0 : AC3 for $File fail"
	        fi
	      fi
	      done
	      cd -
              rm -rf ${UniqueDir[Number]}
	      let Number=Number+1
              printf "\t`date` : Finish %s\n" "$i"
	  else
	      # Einzelne files bearbeiten
              printf "\t`date +"%T"`: MP3 Splitting enable\n"
	      [ ! -z "$MPLAYERMP3SOURCE" ] && M3U=${MPLAYERMP3SOURCE}/`basename ${Titel}`.m3u || M3U=""
	      let SNumber=0
	      LOG=${UniqueDir[Number]}/sync.log
	      for part in $i/[0-9][0-9][0-9]*.vdr
	      do
	          [ "$OSDMONITOR" = "yes" ] && $SVDRPSEND MESG "`echo $0|xargs basename` start for part $i SPLIT ON" > /dev/null 2>&1
		  logger "`echo $0|xargs basename` start for part $i SPLIT ON"
	          pxfiles=""
	  	  USESTREAMS=""
	          UniqueDir[Number]=`mktemp -d ${LTEMPDIR}/VDRSYNC.XXXXXX`
	          mkdir -p ${UniqueDir[Number]}/${Titel}
	          cd ${UniqueDir[Number]}

	          LOG[Number]=${UniqueDir[Number]}/sync.log
	          [ "$OSDMONITOR" = "yes" ] && $SVDRPSEND MESG "Try demux with $DEMUXER" > /dev/null 2>&1
                  printf "\t`date +"%T"`: Start demux with %s\n" ${DEMUXER}
		  logger "$0 : Try demux with $DEMUXER"
                  case `basename $DEMUXER` in
                  vdrsync)
                    nice -n $PRIO $VDRSYNC -audio-only -o ${UniqueDir[Number]} $part > ${LOG[Number]} 2>&1
                    status=$?
                    if [ $status -ne 0 ]
                    then
                      echo "ERROR : $VDRSYNC  rc=$status"
	              [ "$OSDMONITOR" = "yes" ] && $SVDRPSEND MESG "ERROR : $VDRSYNC  rc=$status" > /dev/null 2>&1
		      logger "ERROR : $VDRSYNC  rc=$status"
                      # Cleaning
                      cd $VDRCONVERTDIR
                      rm -rf ${UniqueDir[Number]}
                      Exit
                    fi
                    ;;
                  vdrsync2)
                    nice -n $PRIO $VDRSYNC -audio-only -basename 001 -script-output $VDRSYNC_OPTS -o ${UniqueDir[Number]} $part > ${LOG[Number]} 2>&1
                    status=$?
                    if [ $status -ne 0 ]
                    then
                      echo "ERROR : $VDRSYNC  rc=$status"
	              [ "$OSDMONITOR" = "yes" ] && $SVDRPSEND MESG "ERROR : $VDRSYNC  rc=$status" > /dev/null 2>&1
		      logger "ERROR : $VDRSYNC  rc=$status"
                      # Cleaning
                      cd $VDRCONVERTDIR
                      rm -rf ${UniqueDir[Number]}
                      Exit
                    fi
                    ;;
                  px)
                    # Virtuellen X-Server starten
                    #$XVFB :1 >/dev/null 2>&1 &
                    #export DISPLAY=:1.0
    
                    vdrfiles=$part
    
                    for l in $vdrfiles
                    do
                      let len=`$LS -Ls $l|awk '{print $1}'`
                      [ $len -gt 1 ] && pxfiles="${pxfiles} ${l}"
                    done
    
                    # Project X starten
                    nice -n $PRIO $JAVA -jar $PX -c $PXINI -o ${UniqueDir[Number]} $pxfiles > ${LOG[Number]} 2>&1
                    status=$?
        
                    # Virtuellen X-Server beenden
                    #$KILL -15 $XVFB >/dev/null
                    if [ $status -ne 0 ]
                    then
                      echo "ERROR : $PX  rc=$status"
	              [ "$OSDMONITOR" = "yes" ] && $SVDRPSEND MESG "ERROR : $PX  rc=$status" > /dev/null 2>&1
		      logger "ERROR : $PX  rc=$status"
                      # Cleaning
                      cd $VDRCONVERTDIR
                      rm -rf ${UniqueDir[Number]}
                      Exit
                    fi
                    ;;
                  pva)
                    # VDR Files zusammenfuehren
                    cat $part >> ${UniqueDir[Number]}/001.vdr
                    # Winpfad erstellen
              	    WINEPFAD=`echo ${UniqueDir[Number]}|sed 's/\//\\\/g'`
              	    WINEFILE="demux \"Z:${WINEPFAD}\\001.vdr\" \"Z:${WINEPFAD}\\001.mpv\" \"Z:${WINEPFAD}\\001.mpa\""
                    ## Jobfile anlegen
                    echo "offeryn pvas job v000001" > ${UniqueDir[Number]}/demux.ajb
                    echo "\$JOB" >> ${UniqueDir[Number]}/demux.ajb
                    echo "$WINEFILE" >> ${UniqueDir[Number]}/demux.ajb
                    cat $VDRCONVERTDIR/share/vdrconvert/pva/demux.template >> ${UniqueDir[Number]}/demux.ajb
    
                    #$XVFB :1 >/dev/null 2>&1 &
                    #export DISPLAY=:1.0
    
                    nice -n $PRION $WINE $VDRCONVERTDIR/share/vdrconvert/pva/cPVAS.exe ${UniqueDir[Number]}/demux.ajb > ${LOG[Number]} 2>&1
                    #$KILL -15 $XVFB /dev/null
                    ;;
                  *)
                    echo "No support for Demuxer $DEMUXER"
                    logger "No support for Demuxer $DEMUXER"
                  ;;
                  esac

	          if [ -z "$MP3USESTREAMS" ] 
	          then
		     for ii in `$LS ${UniqueDir[Number]}/*.mpa ${UniqueDir[Number]}/*.mp2 2>/dev/null`
		     do
		         USESTREAMS="$USESTREAMS `echo $ii|xargs basename`"
		     done
		  else
		         USESTREAMS=$MP3USESTREAMS
	          fi

	          for AUDIO in $USESTREAMS
	          do
	           if [ -f ${UniqueDir[Number]}/$AUDIO ]
	           then
	              if [ "$MP3_USE_MPG123" != "yes" ]
	              then
	                  [ "$OSDMONITOR" = "yes" ] && $SVDRPSEND MESG "start LAME for ${Titel}.mp3" > /dev/null 2>&1
                          printf "\t`date +"%T"`: Start LAME for %s in %s with $MP3_OPTS\n" "${AUDIO}" "${Titel}"
	                  nice -n ${PRIO} $LAME --mp2input $MP3_OPTS ${UniqueDir[Number]}/$AUDIO ${UniqueDir[Number]}/${Titel}.mp3 >/dev/null 2>&1
	              else
	                  [ "$OSDMONITOR" = "yes" ] && $SVDRPSEND MESG "start mpg123|lame for ${Titel}.mp3" > /dev/null 2>&1
                          printf "\t`date +"%T"`: Start LAME for %s in %s with $MP3_OPTS\n" "${AUDIO}" "${Titel}"
	                  nice -n $PRIO mpg123 -s -w - ${UniqueDir[Number]}/$AUDIO | $LAME $MP3_OPTS - ${UniqueDir[Number]}/${Titel}.mp3 >/dev/null 2>&1
	                  rm -f out.$$.wav
	              fi

		      if [ -f ${UniqueDir[Number]}/${Titel}.mp3 ]
		      then
		        let SNumber=SNumber+1
		        let index=1
		        until [ ! -f ${MP3_DESTDIR}/${Titel}_${Number}-$index.mp3 ]
		        do
			   let index=index+1
		        done
		        cp ${UniqueDir[Number]}/${Titel}.mp3 ${MP3_DESTDIR}/${Titel}_${Number}-$index.mp3
			File=${MP3_DESTDIR}/${Titel}_${Number}-$index.mp3
		        [ ! -z "$M3U" ] && echo "$File"|cut -f3- -d '/' >> $M3U
		        [ "$OSDMONITOR" = "yes" ] && $SVDRPSEND MESG "MP3 for $File success" > /dev/null 2>&1
                        printf "\t`date +"%T"`: MP3 for %s success\n" "$File"
			logger "$0 : MP3 for $File success"
		      else
                        printf "\t`date +"%T"`: MP3 for %s fail\n" "$File"
		        [ "$OSDMONITOR" = "yes" ] && $SVDRPSEND MESG "MP3 for $File fail" > /dev/null 2>&1
			logger "$0 : MP3 for $File fail"
		      fi
		    fi
	            if [ "$MP3_AUTOWRITE" = "yes" ]
                    then
		        echo "$File:CD:DEL" >> $VCOQUEUEDIR/burn
	            fi
		  done
	          cd -
                  rm -rf ${UniqueDir[Number]}
	          let Number=Number+1
	      done
              printf "\t`date` : Finish %s with splitting\n" "$i"
	  fi
      done
      # Cleaning
      printf "\t`date +"%T"` Parts from List : \n"
      let part=0
      for i in $CMDLIN
      do
      	      let part=part+1
	      printf "\t\t %5d) %s\n" $part "$i"
      done
      printf "\t`date +"%T"` completed\n"
      cp $NewJobs $NewJobs.$$
      grep -x -v "$CMDLIN" $NewJobs.$$ > $NewJobs 
      rm $NewJobs.$$
    done
    rm $NewJobs
  fi
else
      echo "ERROR : ${MP3_DESTDIR} or ${LTEMPDIR} are not writable. $0 exit"
fi
printf "`date +"%d-%m-%2Y %T"` : Session %s end\n" "$0"
Exit
