#!/bin/sh
# Version: 0.1.0
# Author: Dimitrios Dimitrakos mail@dimitrios.de
# $Id$

. ~/.vdrconvert/vdrconvert.env




PIDFILE="$VCORUNDIR/`basename ${0}.pid`"
echo "$$" >> $PIDFILE

trap do_clean SIGINT SIGQUIT SIGTERM 
do_clean() {
	if [ -f $PIDFILE ]
	then
	    TEMPPID=$LTEMPDIR/`basename $PIDFILE`.$$
	    mv $PIDFILE $TEMPPID
	    status=$?
	    if [ $status -eq 0 ]
	    then
	        [ `cat $TEMPPID|wc -l` -gt 0 ] && cat $TEMPPID|grep -v $$ > $PIDFILE 
	    fi
	    [ -f $TEMPPID ] && rm $TEMPPID
	fi
	exit
}

Exit() {
	do_clean
}

NewJobs=$1
JOBFIL=$2
LOGFILE=$3


[ "$DEBUG" = "yes" ] && set -x 

printf "`date +"%d-%m-%2Y %T"` : Session %s begin\n" "$0"

LTEMPDIR=${TEMPDIR}/${JOBFIL}

[ -z "$SVCD_DESTDIR" ]   && SVCD_DESTDIR=$DESTDIR/vcd 
[ -z "$SVCD_TITLEDATE" ] && SVCD_TITLEDATE=$CONV_TITLEDATE

[ -d $SVCD_DESTDIR ] || mkdir -p $SVCD_DESTDIR 
[ -d $LTEMPDIR ] || mkdir -p $LTEMPDIR

[ -z "$USETOSVCD" ]		&& USETOSVCD="yes"
[ -z "$SVCD_AUTOWRITE" ]	&& SVCD_AUTOWRITE=no

if [ -w ${LTEMPDIR} -a -w ${SVCD_DESTDIR} ]
then

  let NLLINES=`cat $VCOQUEUEDIR/${JOBFIL}|nl|wc -l|awk '{ print $1 }'`
  let ALINES=`cat $VCOQUEUEDIR/${JOBFIL}|wc -l|awk '{ print $1 }'`

  if [ $ALINES -ge 1 ]
  then
    TEMPJOBFILE=/$LTEMPDIR/${JOBFIL}.u.$$
    > $TEMPJOBFILE
    printf "%s\n" "`cat $VCOQUEUEDIR/${JOBFIL}|head -n 1`" > $NewJobs
    let LINE=2
    while [ $LINE -le $ALINES ]
    do
	printf "%s\n" "`cat $VCOQUEUEDIR/${JOBFIL}|head -n $LINE|tail -n 1`" >> $TEMPJOBFILE
	let LINE=LINE+1
    done
    [ $NLLINES -gt $ALINES ] && printf "%s" "`cat $VCOQUEUEDIR/${JOBFIL}|tail -n 1`" >> $TEMPJOBFILE
    cp $TEMPJOBFILE $VCOQUEUEDIR/${JOBFIL} && rm $TEMPJOBFILE
    while [ `cat $NewJobs|grep ^${VDRROOT}|wc -l` -gt 0 ]
    do
      CMDLIN=`head -n 1 $NewJobs`   # Job auslesen
      let Number=1
      echo "`date` : Start conversion for $CMDLIN"
      for i in $CMDLIN
      do
          printf "\t`date` : Begin conversion %s\n" "$i"
	  UniqueDir[Number]=`mktemp -d ${LTEMPDIR}/SVCD.XXXXXX`
	  mkdir -p ${UniqueDir[Number]}
	  cd ${UniqueDir[Number]}
	  r=`echo $VDRROOT|sed 's/\// /g'|wc -w`
	  spalten=`echo $i|sed 's/\// /g'|wc -w`
	  Record=`echo $i|sed 's/\%//g'|cut -f $spalten -d '/'`
	  [ $[$r+2] -lt $[$spalten-1] ] && SubTitel=`echo $i|sed 's/\%//g'|cut -f $[$r+2]-$[$spalten-1] -d '/'` || SubTitel=""
	  Datum=`basename $i|cut -f1 -d'.'`
	  if [ -z "$SubTitel" ]
	  then
		[ "$SVCD_TITLEDATE" = "yes" ] && Titel=${Datum}_${Record} ||Titel=${Record}
	  else
		[ "$SVCD_TITLEDATE" = "yes" ] && Titel=${SubTitel}/${Datum}_${Record} || Titel=${SubTitel}/${Record}
	  fi
	  [ ! -d ${UniqueDir[Number]}/${Titel} ] && mkdir -p ${UniqueDir[Number]}/${Titel}
	  if [ "$USETOSVCD" = "yes" ]
	  then
              printf "\t`date +"%T"`: Start TOSVCD for %s.\n" ${Titel} 
	      [ ! -z "${SVCD_OPTS}" ] && printf "\t`date +"%T"`: Opts : %s\n" "${SVCD_OPTS}" 
	      LOG[Number]=${UniqueDir[Number]}/vcd.log
	      nice -n $PRIO $TOSVCD ${SVCD_OPTS} -o ${UniqueDir[Number]}/${Titel} $i >/dev/null 2>&1
	      [ "$DEBUG" = "yes" ] && cat ${LOG[Number]}
	  else
	      echo "At the moment only tosvcd available"
	  fi
	  if [ ! -d ${SVCD_DESTDIR}/${Titel} ]
	  then
		    mkdir -p ${SVCD_DESTDIR}/${Titel}
	            mv ${UniqueDir[Number]}/${Titel}*.bin ${SVCD_DESTDIR}/${Titel}
	            mv ${UniqueDir[Number]}/${Titel}*.cue ${SVCD_DESTDIR}/${Titel}
		    File=${SVCD_DESTDIR}/${Titel}
	  else
		    let index=1
		    until [ ! -d ${SVCD_DESTDIR}/${Titel}-${index} ]
		    do
		        let index=index+1
		    done
		    mkdir -p ${SVCD_DESTDIR}/${Titel}-${index}
	            mv ${UniqueDir[Number]}/${Titel}*.bin ${SVCD_DESTDIR}/${Titel}-${index}
	            mv ${UniqueDir[Number]}/${Titel}*.cue ${SVCD_DESTDIR}/${Titel}-${index}
		    File=${SVCD_DESTDIR}/${Titel}-${index}
	  fi
	  cd -
	  if [ "$SVCD_AUTOWRITE" = "yes" ] 
	  then
	    for burnfile in ${File}/*.cue
	    do
	       echo "$burnfile:CUE:DEL" >> $VCOQUEUEDIR/burn
	    done	
	  fi
          rm -rf ${UniqueDir[Number]}
          printf "\t`date` : Finish %s\n" "$i"
     done
     echo "`date` : Parts from $CMDLIN completed"
     cp $NewJobs $NewJobs.$$
     grep -x -v "$CMDLIN" $NewJobs.$$ > $NewJobs 
     rm $NewJobs.$$
  done
  rm $NewJobs
  fi
else
      echo "ERROR : ${SVCD_DESTDIR} or ${LTEMPDIR} are not writable. $0 exit"
fi
printf "`date +"%d-%m-%2Y %T"` : Session %s end\n" "$0"
Exit
